var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { createPortal } from 'react-dom';
import Context from '../Context/instance.js';

var Loading = (_temp = _class = function (_Component) {
  _inherits(Loading, _Component);

  function Loading(props, context) {
    _classCallCheck(this, Loading);

    return _possibleConstructorReturn(this, _Component.call(this, props, context));
  }

  Loading.prototype.render = function render() {
    var _this2 = this;

    // 全局配置
    var _context$locale = this.context.locale,
        locale = _context$locale === undefined ? {} : _context$locale;

    if (!locale) locale = {};

    var _props = this.props,
        portal = _props.portal,
        type = _props.type,
        _props$maskAttribute = _props.maskAttribute,
        maskAttribute = _props$maskAttribute === undefined ? {} : _props$maskAttribute,
        iconAttribute = _props.iconAttribute,
        _props$captionAttribu = _props.captionAttribute,
        captionAttribute = _props$captionAttribu === undefined ? {} : _props$captionAttribu,
        _props$caption = _props.caption,
        caption = _props$caption === undefined ? locale['loading'] || '正在加载...' : _props$caption,
        children = _props.children,
        others = _objectWithoutProperties(_props, ['portal', 'type', 'maskAttribute', 'iconAttribute', 'captionAttribute', 'caption', 'children']);

    var content = React.createElement(
      'div',
      null,
      '\u52A0\u8F7D\u4E2D...'
    );
    if (type === 'custom') {
      // 自定义样式
      content = React.createElement(
        'div',
        _extends({}, others, { className: 'loading-custom' + (others.className ? ' ' + others.className : '') }),
        iconAttribute && React.createElement('span', _extends({}, iconAttribute, { className: 'loading-custom-icon' + (iconAttribute.className ? ' ' + iconAttribute.className : '') })),
        caption && React.createElement(
          'p',
          _extends({}, captionAttribute, { className: 'loading-custom-caption' + (captionAttribute.className ? ' ' + captionAttribute.className : '') }),
          caption
        )
      );
    } else if (type === 'filling') {
      // 填料环
      content = React.createElement(
        'div',
        _extends({}, others, { className: 'loading-filling active' + (others.className ? ' ' + others.className : '') }),
        React.createElement('div', { className: 'loading-filling-icon' })
      );
    } else if (type === 'floating') {
      // 流光
      content = React.createElement(
        'div',
        _extends({}, others, { className: 'loading-floating animated' + (others.className ? ' ' + others.className : '') }),
        React.createElement(
          'div',
          { className: 'loading-floating-icon' },
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' }),
          React.createElement('div', { className: 'loading-floating-blade' })
        ),
        caption && React.createElement(
          'div',
          _extends({}, captionAttribute, { className: 'loading-floating-caption' + (captionAttribute.className ? ' ' + captionAttribute.className : '') }),
          caption
        )
      );
    }
    if (portal) {
      return createPortal(React.createElement(
        'div',
        _extends({ ref: function ref(el) {
            _this2.$el = el;
          } }, maskAttribute, { className: 'loading-mask mask active' + (maskAttribute.className ? ' ' + maskAttribute.className : '') }),
        content,
        children
      ), portal);
    }
    return React.createElement(
      'div',
      _extends({ ref: function ref(el) {
          _this2.$el = el;
        } }, maskAttribute, { className: 'loading-mask mask active' + (maskAttribute.className ? ' ' + maskAttribute.className : '') }),
      content,
      children
    );
  };

  return Loading;
}(Component), _class.contextType = Context, _class.defaultProps = {
  type: 'floating'
}, _temp);
export { Loading as default };
Loading.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: PropTypes.object, // 传送至DOM
  type: PropTypes.string, // floating | filling | custom

  maskAttribute: PropTypes.object,
  iconAttribute: PropTypes.object,
  captionAttribute: PropTypes.object,
  caption: PropTypes.node,

  children: PropTypes.node
} : {};