'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _instance = require('../Context/instance.js');

var _instance2 = _interopRequireDefault(_instance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Loading = (_temp = _class = function (_Component) {
  _inherits(Loading, _Component);

  function Loading(props, context) {
    _classCallCheck(this, Loading);

    return _possibleConstructorReturn(this, _Component.call(this, props, context));
  }

  Loading.prototype.render = function render() {
    var _this2 = this;

    // 全局配置
    var _context$locale = this.context.locale,
        locale = _context$locale === undefined ? {} : _context$locale;

    if (!locale) locale = {};

    var _props = this.props,
        portal = _props.portal,
        type = _props.type,
        _props$maskAttribute = _props.maskAttribute,
        maskAttribute = _props$maskAttribute === undefined ? {} : _props$maskAttribute,
        iconAttribute = _props.iconAttribute,
        _props$captionAttribu = _props.captionAttribute,
        captionAttribute = _props$captionAttribu === undefined ? {} : _props$captionAttribu,
        _props$caption = _props.caption,
        caption = _props$caption === undefined ? locale['loading'] || '正在加载...' : _props$caption,
        children = _props.children,
        others = _objectWithoutProperties(_props, ['portal', 'type', 'maskAttribute', 'iconAttribute', 'captionAttribute', 'caption', 'children']);

    var content = _react2.default.createElement(
      'div',
      null,
      '\u52A0\u8F7D\u4E2D...'
    );
    if (type === 'custom') {
      // 自定义样式
      content = _react2.default.createElement(
        'div',
        _extends({}, others, { className: 'loading-custom' + (others.className ? ' ' + others.className : '') }),
        iconAttribute && _react2.default.createElement('span', _extends({}, iconAttribute, { className: 'loading-custom-icon' + (iconAttribute.className ? ' ' + iconAttribute.className : '') })),
        caption && _react2.default.createElement(
          'p',
          _extends({}, captionAttribute, { className: 'loading-custom-caption' + (captionAttribute.className ? ' ' + captionAttribute.className : '') }),
          caption
        )
      );
    } else if (type === 'filling') {
      // 填料环
      content = _react2.default.createElement(
        'div',
        _extends({}, others, { className: 'loading-filling active' + (others.className ? ' ' + others.className : '') }),
        _react2.default.createElement('div', { className: 'loading-filling-icon' })
      );
    } else if (type === 'floating') {
      // 流光
      content = _react2.default.createElement(
        'div',
        _extends({}, others, { className: 'loading-floating animated' + (others.className ? ' ' + others.className : '') }),
        _react2.default.createElement(
          'div',
          { className: 'loading-floating-icon' },
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' }),
          _react2.default.createElement('div', { className: 'loading-floating-blade' })
        ),
        caption && _react2.default.createElement(
          'div',
          _extends({}, captionAttribute, { className: 'loading-floating-caption' + (captionAttribute.className ? ' ' + captionAttribute.className : '') }),
          caption
        )
      );
    }
    if (portal) {
      return (0, _reactDom.createPortal)(_react2.default.createElement(
        'div',
        _extends({ ref: function ref(el) {
            _this2.$el = el;
          } }, maskAttribute, { className: 'loading-mask mask active' + (maskAttribute.className ? ' ' + maskAttribute.className : '') }),
        content,
        children
      ), portal);
    }
    return _react2.default.createElement(
      'div',
      _extends({ ref: function ref(el) {
          _this2.$el = el;
        } }, maskAttribute, { className: 'loading-mask mask active' + (maskAttribute.className ? ' ' + maskAttribute.className : '') }),
      content,
      children
    );
  };

  return Loading;
}(_react.Component), _class.contextType = _instance2.default, _class.defaultProps = {
  type: 'floating'
}, _temp);
exports.default = Loading;
Loading.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: _propTypes2.default.object, // 传送至DOM
  type: _propTypes2.default.string, // floating | filling | custom

  maskAttribute: _propTypes2.default.object,
  iconAttribute: _propTypes2.default.object,
  captionAttribute: _propTypes2.default.object,
  caption: _propTypes2.default.node,

  children: _propTypes2.default.node
} : {};
module.exports = exports['default'];